<?php

namespace EventPortal\Tests\Unit\Event\Actions;

use EventPortal\Domain\Event\Actions\TransitionEvent;
use EventPortal\Domain\Event\Models\Event;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;
use SM\SMException;

class TransitionEventTest extends TestCase
{
    use RefreshDatabase;

    /** @test **/
    public function can_transition()
    {
        $event = factory(Event::class)->state('unpublished')->create();

        (new TransitionEvent())->execute($event, 'open');

        $this->assertEquals('registration_open', $event->status);
    }

    /** @test **/
    public function cannot_transition_to_state_that_is_not_allowed()
    {
        $this->expectException(SMException::class);

        $event = factory(Event::class)->state('unpublished')->create();

        (new TransitionEvent())->execute($event, 'close');
    }
}
